
require 'fileutils'

# proceed with install
@ninjaPackages = Array.new
@ninjaFiles = Array.new
@ninjaLaunchDaemons = Array.new
@ninjaLaunchAgents = Array.new

# agents
@ninjaLaunchAgents.push "com.xrite.device.message.plist"
@ninjaLaunchAgents.push "com.xrite.device.xritelegacyd.plist"
@ninjaLaunchAgents.push "com.xrite.device.restoreuserxrd.plist"

# daemons
@ninjaLaunchDaemons.push "com.xrite.device.colormunki.plist"
@ninjaLaunchDaemons.push "com.xrite.device.goldeneye.plist"
@ninjaLaunchDaemons.push "com.xrite.device.i1.plist"
@ninjaLaunchDaemons.push "com.xrite.device.i1d.plist"
@ninjaLaunchDaemons.push "com.xrite.device.i1d3.plist"
@ninjaLaunchDaemons.push "com.xrite.device.i1isis.plist"
@ninjaLaunchDaemons.push "com.xrite.device.xritedeviced.plist"
@ninjaLaunchDaemons.push "com.xrite.device.xrdd.plist"
@ninjaLaunchDaemons.push "com.xrite.device.restorexrd.plist"

# files
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/ColorMunkiDeviceService.app"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.colormunki.plist"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/GoldenEyeDeviceService.app"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.goldeneye.plist"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/Calibrations"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.i1d3.plist"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1DisplayDeviceService.app"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.i1d.plist"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1iSisDeviceService.app"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.i1isis.plist"
@ninjaFiles.push "/Library/Application Support/Developer/Shared/Xcode/CustomDataViews/XRiteDeviceDataFormatter.bundle"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/message.app"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/xrdd"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/xritelegacyd.app"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/xritedeviced"
@ninjaFiles.push "/Library/Application Support/X-Rite/Frameworks/XRiteDevice.framework"
@ninjaFiles.push "/Library/LaunchAgents/com.xrite.device.message.plist"
@ninjaFiles.push "/Library/LaunchAgents/com.xrite.device.xritelegacyd.plist"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.xritedeviced.plist"
@ninjaFiles.push "/Library/PreferencePanes/X-Rite Device Services.prefPane"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1ProDeviceService.app"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.i1.plist"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/ColorMunkiDeviceService.app"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.colormunki.plist"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/message.app"
@ninjaFiles.push "/Library/LaunchAgents/com.xrite.device.message.plist"
@ninjaFiles.push "/Library/Frameworks/XRiteDevice.framework"
@ninjaFiles.push "/Library/Receipts/ColorMunkiNinja.pkg"
@ninjaFiles.push "/Library/Receipts/message.pkg"
@ninjaFiles.push "/Library/Receipts/ninja.pkg"
@ninjaFiles.push "/Library/Receipts/XRD GoldenEye.pkg"
@ninjaFiles.push "/Library/Receipts/XRD Manager.pkg"
#@ninjaFiles.push "/Library/Application Support/X-Rite/Devices"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/ColorMunki.xrdevice"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1d2.xrdevice"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1d3.xrdevice"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1IO.xrdevice"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1iSis.xrdevice"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/i1Pro.xrdevice"
@ninjaFiles.push "/Library/Application Support/X-Rite/Devices/rm200.xrdevice"
@ninjaFiles.push "/Library/Receipts/comxritedevicerestoreuxrd.pkg"
@ninjaFiles.push "/Library/Receipts/comxritedevicerestorexrd.pkg"
@ninjaFiles.push "/Library/Receipts/comxritedevicexrdd.pkg"
@ninjaFiles.push "/Library/Receipts/xritedevice.pkg"
@ninjaFiles.push "/Library/Receipts/xriteDeviceServices.pkg"
@ninjaFiles.push "/Library/Application Support/X-Rite/Frameworks/XRiteDevice.framework"
@ninjaFiles.push "/Library/LaunchAgents/com.xrite.device.restoreuxrd.plist"
@ninjaFiles.push "/Library/LaunchAgents/com.xrite.device.softwareupdate.plist"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.restorexrd.plist"
@ninjaFiles.push "/Library/LaunchDaemons/com.xrite.device.xrdd.plist"
@ninjaFiles.push "/Library/PreferencePanes/X-Rite Device Services.prefPane"
@ninjaFiles.push "/Library/Logs/X-Rite/Device"


def RemoveNinjaFiles()
  
  puts "Removing files..."
  
  @ninjaFiles.each do |file|
    
    puts "Trying to remove '#{file}'..."
    
    if File.exists? file then
      puts "Removing '#{file}'..."
      FileUtils.remove_entry(file)
    else
      puts "File does not exists: '#{file}'"
    end
    
    `rm -R '#{file}'`
    
  end
  
end

def GetNinjaPackages()
  packages = `pkgutil --pkgs --volume /`
  packages.each_line do |package|
    package = package.chomp

    if package.include? "com.xrite.device" then
      puts "Found package '#{package}'"
      @ninjaPackages.push package
    elsif package.include? "com.xrite.pkg.xrd" then
      puts "Found package '#{package}'"
      @ninjaPackages.push package
    end
  end
  
end

def RemoveNinjaPackages()
  
  puts "Removing packages..."
  
  @ninjaPackages.each do |package|
    puts "Forgetting package '#{package}'"
    output = `pkgutil --forget #{package}`
  end
  
end

def StopDaemons()

  puts "Stopping daemons..."

   @ninjaLaunchDaemons.each do |name|
     
     file = "/Library/LaunchDaemons/" + name
     puts "Stopping: '#{file}'"
     if File.exists? file then
       `launchctl unload #{file}`
     end
     
     `launchctl unload '#{file}'`
     
   end


end

def KillUserDaemons()
  
  puts "Stopping agents/daemons..."
  
  `killall -m XRD Software Update`
  `killall -m ColorMunkiDeviceService`
  `killall -m GoldenEyeDeviceService`
  `killall -m i1DisplayDeviceService`
  `killall -m i1iSisDeviceService`
  `killall -m i1ProDeviceService`
  `killall -m xritelegacyd`
  `killall -m message`
  `killall -m xritedeviced`
  `killall -m xrdd`
  
end

def Uninstall()
  StopDaemons()
  GetNinjaPackages()
  RemoveNinjaPackages()
  RemoveNinjaFiles()
  KillUserDaemons()
end

Uninstall()


