
require 'fileutils'

if ! File.exists?( "/var/xrite" ) then
  `mkdir "/var/xrite"`
end

package = "/var/xrite/XRD Manager.pkg"
packageInfoFile = "/var/xrite/XRD Manager.pkg/Contents/Info"

installPackage = File.expand_path( ENV['installer_path'] )
installPackageInfoFile = installPackage + "/Contents/Info"

if File.exists?(packageInfoFile+".plist") then
  packageVersion = `defaults read '#{packageInfoFile}' CFBundleShortVersionString`
  packageVersion = packageVersion.to_f
else
  packageVersion = 0.0
end

if File.exists?(installPackageInfoFile+".plist") then
  installPackageVersion = `defaults read '#{installPackageInfoFile}' CFBundleShortVersionString`
  installPackageVersion = installPackageVersion.to_f
else
  installPackageVersion = 0.0
end

puts "Installed version is #{packageVersion}"
puts "New version is #{installPackageVersion}"

if installPackageVersion >= packageVersion then
  
  # need to copy new package over
  if File.exists?(package) then
    `rm -R '#{package}'`
  end
  
  puts "Copying installer over for safe storage"
  `cp -R '#{installPackage}' '#{package}'`
  
end

exit 0