//
//  CDCommandResponse.h
//  CoreDevice
//
//  Created by Alex Cohen on 9/16/09.
//  Copyright 2009 Toomuchspace. All rights reserved.
//

#if defined(TARGET_OS_IPHONE) && TARGET_OS_IPHONE
#import <CDObject.h>
#else
#import <CoreDevice/CDObject.h>
#endif

@class CDCommand;
@class CDReceipt;

extern NSString* const CDCommandResponseErrorDomain;
extern NSString* const CDCommandResponseErrorCommand;

@interface CDCommandResponse : CDObject {
}

@property (readonly,retain) CDCommand* command;
@property (readonly,retain) CDReceipt* receipt;
@property (readonly,retain) NSError* error;
@property (readonly,retain) NSString* deviceName;

@property (readonly) BOOL isTimeoutError;

@end



@interface CDCommandResponse (responseTypes)

@property (readonly) BOOL isResponseToBeginCalibration;
@property (readonly) BOOL isResponseToCalibration;
@property (readonly) BOOL isResponseToMeasure;

@end

@interface CDCommandResponse (measurements)

@property (readonly) BOOL hasMeasurements;
@property (readonly,retain) NSArray* measurements;

@end

@interface CDCommandResponse (data)

@property (readonly,retain) NSData* data;

@end


