//
//  CDDeviceCenterBrowser.h
//  iPhoneDevice
//
//  Created by Alex Cohen on 12/17/09.
//  Copyright 2009 BedroomCode. All rights reserved.
//

#if defined(TARGET_OS_IPHONE) && TARGET_OS_IPHONE
#import <CDObject.h>
#else
#import <CoreDevice/CDObject.h>
#endif

extern NSString* const CDDeviceCenterNameKey;
extern NSString* const CDDeviceCenterAddressKey;
extern NSString* const CDDeviceCenterPortKey;

@class CDDeviceCenter;
@protocol CDDeviceCenterBrowserDelegate;

@interface CDDeviceCenterBrowser : CDObject {
	NSMutableArray*		centers;
	id<CDDeviceCenterBrowserDelegate>	delegate;
}

@property (assign) id<CDDeviceCenterBrowserDelegate> delegate;
@property (readonly,copy) NSArray* centers;

+ (CDDeviceCenterBrowser*)deviceCenterBrowser;

- (void)startBrowsing;
- (CDDeviceCenter*)deviceCenterForName:(NSString*)name;

@end

@protocol CDDeviceCenterBrowserDelegate <NSObject>

- (void)deviceCenterBrowser:(CDDeviceCenterBrowser*)browser didFindCenter:(NSDictionary*)centerInfo;
- (void)deviceCenterBrowser:(CDDeviceCenterBrowser*)browser didRemoveCenter:(NSDictionary*)centerInfo;

@end


