//
//  CDUSBConnection.h
//  CoreDevice
//
//  Created by Alex Cohen on 1/22/10.
//  Copyright 2010 BedroomCode. All rights reserved.
//

#if defined(TARGET_OS_IPHONE) && TARGET_OS_IPHONE
#import <CDObject.h>
#else
#import <CoreDevice/CDObject.h>
#endif

@protocol CDUSBConnectionDelegate;

@interface CDUSBConnection : CDObject {
	id<CDUSBConnectionDelegate>	delegate;
}

@property (readonly) NSInteger productID;
@property (readonly) NSInteger vendorID;
@property (readonly) BOOL isAttached;
@property (readonly,copy) NSString* name;
@property (assign) id<CDUSBConnectionDelegate>	delegate;

- (id)initWithProductID:(NSInteger)productID vendorID:(NSInteger)vendorID;

- (void)startListening;
- (void)stopListening;

@end

@protocol CDUSBConnectionDelegate <NSObject>

- (void)usbConnectionDidAttach:(CDUSBConnection*)usb;
- (void)usbConnectionDidDetach:(CDUSBConnection*)usb;

@end

